net.sf.saxon.expr.instruct

## Class Instruction

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction

- All Implemented Interfaces:
    Serializable, SourceLocator, LocationProvider, SaxonLocator, TailCallReturner, InstructionInfo, Locator
  Direct Known Subclasses:
    AnalyzeString, ApplyImports, ApplyTemplates, Assign, Block, BreakInstr, CallTemplate, Choose, CopyOf, Doctype, ForEach, ForEachGroup, Fork, IterateInstr, LocalParamBlock, LocalParamSetter, MergeInstr, Message, NextIteration, ParentNodeConstructor, ProcessRegexMatchInstruction, ResultDocument, SimpleNodeConstructor, StreamInstr, TraceExpression, UseAttributeSets, While

      public abstract class Instruction
      extends Expression
      implements SourceLocator, TailCallReturner

  Abstract superclass for all instructions in the compiled stylesheet. This represents a compiled instruction, and as such, the minimum information is retained from the original stylesheet.
  Note: this class implements SourceLocator: that is, it can identify where in the stylesheet the source instruction was located.
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Instruction()` Constructor

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static ParameterSet` | `assembleParams(XPathContext context, WithParam[] actualParams)` Assemble a ParameterSet.
    `static ParameterSet` | `assembleTunnelParams(XPathContext context, WithParam[] actualParams)` Assemble a ParameterSet.
    `int` | `computeCardinality()` Get the cardinality of the sequence returned by evaluating this instruction
    `int` | `computeSpecialProperties()` Get the static properties of this expression (other than its type).
    `boolean` | `createsNewNodes()` Determine whether this instruction creates new nodes.
    `protected static XPathException` | `dynamicError(SourceLocator loc, XPathException error, XPathContext context)` Construct an exception with diagnostic information.
    `CharSequence` | `evaluateAsString(XPathContext context)` Evaluate an expression as a String.
    `Item` | `evaluateItem(XPathContext context)` Evaluate an expression as a single item.
    `int` | `getConstructType()` Get the type of this expression for use in tracing and diagnostics
    `String` | `getExpressionName()` Get a name identifying the kind of expression, in terms meaningful to a user.
    `int` | `getImplementationMethod()` An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
    `String` | `getInstructionName()` Get a name identifying the kind of instruction, in terms meaningful to a user.
    `int` | `getInstructionNameCode()` Get the namecode of the instruction for use in diagnostics
    `ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the items returned by evaluating this instruction
    `protected SequenceIterator<? extends Item>` | `getIteratorFromProcessMethod(XPathContext context)` Helper method to construct an iterator over the results of the expression when all that the expression itself offers is a process() method.
    `SourceLocator` | `getSourceLocator()` Get a SourceLocator identifying the location of this instruction
    `boolean` | `isXSLT()` Establish whether this is an XSLT instruction or an XQuery instruction (used to produce appropriate diagnostics)
    `SequenceIterator<? extends Item>` | `iterate(XPathContext context)` Return an Iterator to iterate over the values of a sequence.
    `void` | `process(XPathContext context)` Process the instruction, without returning any tail calls
    `abstract TailCall` | `processLeavingTail(XPathContext context)` ProcessLeavingTail: called to do the real work of this instruction.
    `Expression` | `promote(PromotionOffer offer, Expression parent)` Offer promotion for this subexpression.
    `protected void` | `promoteInst(PromotionOffer offer)` Handle promotion offers, that is, non-local tree rewrites.
    `abstract Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression.

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, copy, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, explain, getCardinality, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getExpressionCompiler, getHostLanguage, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getStreamability, getStreamingAdjunct, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, iterateSubExpressionInfo, iterateSubExpressions, markTailFunctionCalls, optimize, replaceSubExpression, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toPattern, toStreamingPattern, toString, typeCheck, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javax.xml.transform.SourceLocator

      `getColumnNumber, getLineNumber, getPublicId, getSystemId`

- - ### Constructor Detail

    - #### Instruction

          public Instruction()

      Constructor

  - ### Method Detail

    - #### getImplementationMethod

          public int getImplementationMethod()

      An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is prefered. For instructions this is the process() method.
      Overrides:
        `getImplementationMethod` in class `Expression`
      Returns:
        the implementation method, for example `Expression.ITERATE_METHOD` or `Expression.EVALUATE_METHOD` or `Expression.PROCESS_METHOD`

    - #### getInstructionNameCode

          public int getInstructionNameCode()

      Get the namecode of the instruction for use in diagnostics
      Returns:
        a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

    - #### getInstructionName

          public String getInstructionName()

      Get a name identifying the kind of instruction, in terms meaningful to a user. This method is not used in the case where the instruction name code is a standard name (<1024).
      Returns:
        a name identifying the kind of instruction, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the instruction.

    - #### getExpressionName

          public String getExpressionName()

      Get a name identifying the kind of expression, in terms meaningful to a user.
      Overrides:
        `getExpressionName` in class `Expression`
      Returns:
        a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the expression.

    - #### getItemType

          public ItemType getItemType(TypeHierarchy th)

      Get the item type of the items returned by evaluating this instruction
      Specified by:
        `getItemType` in class `Expression`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        the static item type of the instruction

    - #### computeCardinality

          public int computeCardinality()

      Get the cardinality of the sequence returned by evaluating this instruction
      Specified by:
        `computeCardinality` in class `Expression`
      Returns:
        the static cardinality

    - #### processLeavingTail

          public abstract TailCall processLeavingTail(XPathContext context)
                                               throws XPathException

      ProcessLeavingTail: called to do the real work of this instruction. This method must be implemented in each subclass. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.
      Specified by:
        `processLeavingTail` in interface `TailCallReturner`
      Parameters:
        `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
      Returns:
        null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the instruction

    - #### process

          public void process(XPathContext context)
                       throws XPathException

      Process the instruction, without returning any tail calls
      Overrides:
        `process` in class `Expression`
      Parameters:
        `context` - The dynamic context, giving access to the current node, the current variables, etc.
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### getSourceLocator

          public SourceLocator getSourceLocator()

      Get a SourceLocator identifying the location of this instruction
      Returns:
        the location of this instruction in the source stylesheet or query

    - #### dynamicError

          protected static XPathException dynamicError(SourceLocator loc,
                                    XPathException error,
                                    XPathContext context)

      Construct an exception with diagnostic information. Note that this method returns the exception, it does not throw it: that is up to the caller.
      Parameters:
        `loc` - the location of the error
        `error` - The exception containing information about the error
        `context` - The controller of the transformation
      Returns:
        an exception based on the supplied exception, but with location information added relating to this instruction

    - #### assembleParams

          public static ParameterSet assembleParams(XPathContext context,
                                    WithParam[] actualParams)
                                             throws XPathException

      Assemble a ParameterSet. Method used by instructions that have xsl:with-param children. This method is used for the non-tunnel parameters.
      Parameters:
        `context` - the XPath dynamic context
        `actualParams` - the set of with-param parameters that specify tunnel="no"
      Returns:
        a ParameterSet
      Throws:
        `XPathException` - if an error occurs evaluating one of the parameters

    - #### assembleTunnelParams

          public static ParameterSet assembleTunnelParams(XPathContext context,
                                          WithParam[] actualParams)
                                                   throws XPathException

      Assemble a ParameterSet. Method used by instructions that have xsl:with-param children. This method is used for the tunnel parameters.
      Parameters:
        `context` - the XPath dynamic context
        `actualParams` - the set of with-param parameters that specify tunnel="yes"
      Returns:
        a ParameterSet
      Throws:
        `XPathException` - if an error occurs evaluating one of the tunnel parameters

    - #### simplify

          public abstract Expression simplify(ExpressionVisitor visitor)
                                       throws XPathException

      Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.
      Overrides:
        `simplify` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
      Returns:
        the simplified expression
      Throws:
        `XPathException` - if an error is discovered during expression rewriting

    - #### computeSpecialProperties

          public int computeSpecialProperties()

      Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.
      Overrides:
        `computeSpecialProperties` in class `Expression`
      Returns:
        a set of flags indicating static properties of this expression

    - #### createsNewNodes

          public boolean createsNewNodes()

      Determine whether this instruction creates new nodes. This implementation returns a default value of false
      Returns:
        true if the instruction creates new nodes (or if it can't be proved that it doesn't)

    - #### promoteInst

          protected void promoteInst(PromotionOffer offer)
                              throws XPathException

      Handle promotion offers, that is, non-local tree rewrites.
      Parameters:
        `offer` - The type of rewrite being offered
      Throws:
        `XPathException` - if an error occurs

    - #### promote

          public Expression promote(PromotionOffer offer,
                           Expression parent)
                             throws XPathException

      Offer promotion for this subexpression. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. This method is always called at compile time.
      Overrides:
        `promote` in class `Expression`
      Parameters:
        `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
        `parent` - the parent of the subexpression
      Returns:
        if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
      Throws:
        `XPathException` - if any error is detected

    - #### evaluateItem

          public Item evaluateItem(XPathContext context)
                            throws XPathException

      Evaluate an expression as a single item. This always returns either a single Item or null (denoting the empty sequence). No conversion is done. This method should not be used unless the static type of the expression is a subtype of "item" or "item?": that is, it should not be called if the expression may return a sequence. There is no guarantee that this condition will be detected.
      Overrides:
        `evaluateItem` in class `Expression`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### iterate

          public SequenceIterator<? extends Item> iterate(XPathContext context)
                                                   throws XPathException

      Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.
      Overrides:
        `iterate` in class `Expression`
      Parameters:
        `context` - supplies the context for evaluation
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### getIteratorFromProcessMethod

          protected final SequenceIterator<? extends Item> getIteratorFromProcessMethod(XPathContext context)
                                                                                 throws XPathException

      Helper method to construct an iterator over the results of the expression when all that the expression itself offers is a process() method. This builds the entire results of the expression as a sequence in memory and then iterates over it.
      Parameters:
        `context` - the dynamic evaluation context
      Returns:
        an iterator over the results of the expression
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### evaluateAsString

          public final CharSequence evaluateAsString(XPathContext context)
                                              throws XPathException

      Evaluate an expression as a String. This function must only be called in contexts where it is known that the expression will return a single string (or where an empty sequence is to be treated as a zero-length string). Implementations should not attempt to convert the result to a string, other than converting () to "". This method is used mainly to evaluate expressions produced by compiling an attribute value template.
      Overrides:
        `evaluateAsString` in class `Expression`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the value of the expression, evaluated in the current context. The expression must return a string or (); if the value of the expression is (), this method returns "".
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression
        `ClassCastException` - if the result type of the expression is not xs:string?

    - #### getConstructType

          public int getConstructType()

      Get the type of this expression for use in tracing and diagnostics
      Specified by:
        `getConstructType` in interface `InstructionInfo`
      Overrides:
        `getConstructType` in class `Expression`
      Returns:
        the type of expression, as enumerated in class `Location`

    - #### isXSLT

          public boolean isXSLT()

      Establish whether this is an XSLT instruction or an XQuery instruction (used to produce appropriate diagnostics)
      Returns:
        true for XSLT, false for XQuery

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.